/* Copyright (C) 1992-1998 The Geometry Center
 * Copyright (C) 1998-2000 Stuart Levy, Tamara Munzner, Mark Phillips
 *
 * This file is part of Geomview.
 * 
 * Geomview is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * Geomview is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with Geomview; see the file COPYING.  If not, write
 * to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
 * USA, or visit http://www.gnu.org.
 */

#if defined(HAVE_CONFIG_H) && !defined(CONFIG_H_INCLUDED)
#include "config.h"
#endif

static char copyright[] = "Copyright (C) 1992-1998 The Geometry Center\n\
Copyright (C) 1998-2000 Stuart Levy, Tamara Munzner, Mark Phillips";


/* Authors: Charlie Gunn, Stuart Levy, Tamara Munzner, Mark Phillips */

#include "bboxP.h"
#include "ndmeshP.h"

/* Hack.  Use BBox_ND_hack() to compute a bounding box that conservatively
 * covers everything -- but ignoring the transform.
 */
BBox *
NDMeshBound(NDMesh *m, Transform T)
{
	register HPointN **p;
	int i, n;
	BBox *b = NULL;

#ifdef BBOX_ND_HACK
	for(i = m->meshd, n = 1; --i >= 0; ) n *= m->mdim[i];
	for(p = m->p; --n >= 0; p++)
	    if(*p)
		b = BBox_ND_hack(b, (*p)->v, (*p)->dim);
#endif
	return b;
}

